mp.Digits(100); 
n1=3;  %the number of initial sources
beta=0.05;%the parameter of adjusting the difusion rate 
sigma=0; %noise,  standard deviation 
data=0.5; %data rate
auc(300,16)=0;
ave_auc(16,5)=0;%the average of auroc

for jj=1:300  %300 relizations
clear A A1 B BB C C1 D D1 N Y a a1 b1 c fpr i j jb jb1 k1 m mo nor p pn r rou t t0 threshold tpr x1 y y0 k
%%%%%%%%%%%%%%%%%% ER networks %%%%%%%%%%%%%
N=mp('50');A=zeros(N);p=mp('0.08'); %%%%%%%N is the network size, p is connection probability%%%%%%%
NN=50;
for i=1:NN
for j=1+i:NN
clear b
b=rand(1,1);
if b<=p
nor=unifrnd(mp('0'),mp('2'),1,1);
A(i,j)=nor;
%A(i,j)=1;  %%%%%%%%%%%% for unweight case
A(j,i)=A(i,j);
end
end
end
%%%%%%%%%%%%%%%%%%%%%end ER networks %%%%%%%%%%%%%

 A1=A;
k1(NN,2)=mp('1');
for i=1:NN
k1(i,1)=i;
k1(i,2)=sum(A(i,:));
end

for i=1:NN
A(i,i)=-k1(i,2);
end
B=beta*A+eye(NN);
%%%%%%%%%%%%%%%%%%% HPB test to identify messengers %%%%%%%%%%%%%%%%%%%%
clear A jb1 
jb1(1:i,1)=1:i;
c=eig(B);
clear ans count r3 d1 y3  C C1     
r3=sort(round(c*10^15)/10^15);
count=diff([r3;max(r3)+1]);       
 d1 = diff(find([1;count]));       
 y3 =[r3(find(count)) d1];
 y3=sortrows(y3,-2);
clear C w
C(1,1:NN)=0; %%%%%%C is the output matrix and the nonzero enrty means which node is messenger%%%%%%%%
y=[]; 
C1=zeros(NN);jb=[];r=[];y0=[];
C1=y3(1,1)*eye(NN)-B;
[r,jb]=rref(double(C1));
jb=jb';
y0 = setdiff(jb1, jb);
for w=1:length(y0)
C(w,y0(w,1))=1;
end
if C(:)==0
    C(1,NN)=1;
end
%%%%%%%%%%%%%%%%%%% end HPB test to identify messengers %%%%%%%%%%%%%%%%%%%%

A=A1;
a=[];t0=100; %%%%%%%%%difussion time step is set to 100
b=randperm(NN);

 a=b(1:n1);  %create sources by random
a=a';
a=sort(a);
k1(:,3:4)=0;
for i=1:length(a)
b=unifrnd(mp('0'),mp('1'),1,1);
k1(a(i,1),3)=b;
k1(a(i,1),4)=b;
clear b
end

%%%%%%%%%%%%%%% difussion process%%%%%%%%%%%%%% 
rou(NN,t0+1)=mp('0');
rou(:,1)=k1(:,4);
for t=1:t0
for i=1:NN
rou(i,t+1)=rou(i,t)+beta*(A1(:,i)'*rou(:,t)-k1(i,2)*rou(i,t));
end
end
%%%%%%%%%%%%%%% end difussion process%%%%%%%%%%%%%%
clear A
 A=B;    
pn0=randperm(NN);
pn=sort(pn0(1:(data*NN))'); %data rate
D1=[]; %%%%%%%%% observation matrix
clear pn0
for k=1:length(pn)
    clear D
    D=C*A^(pn(k,1)-1);            
    D1=[D1;D];
end
clear Y x11 D2 x1  x12

j=1;
tt=10;  %initial observation time is fixed, 10 for example
Y=[];  %%%%%%%%% output vector
clear x11 D2 x1 a
for i=1:length(pn) 
    Y=[Y;C*rou(:,pn(i,1)+tt)];  
end
%y=Y;
clear y
y=Y*(1+sigma*normrnd(0,1));
clear Y
Y=y;
clear y

for j=15:-1:0  %reconstruction time steps is set to 15.
clear D2 x11 x1
D2=D1*A^j;
x11=pinv(D2)*Y;
%x11=D2\Y;
x1=l1eq_pd(x11, D2, [], Y, mp('1e-8'));  %x1 reconstruction initial state at current time step

%%%%%%%%%%%%%%%% acroc%%%%%%%%%%%%%%%%%%%%%%
threshold=sortrows(unique(x1(:,1)),-1);
for a=1:length(threshold)
m=length(find(x1(:,1)>=threshold(a,1)));
mo=length(find(x1(:,1)>=threshold(a,1)&rou(:,1)>=0.1));
tpr(a,1)=threshold(a,1);
tpr(a,2)=mo/length(find(rou(:,1)>=0.1));
fpr(a,1)=threshold(a,1);
fpr(a,2)=(m-mo)/(length(B)-length(find(rou(:,1)>=0.1)));
end

for b1=1:a-1
if tpr(b1,2)==tpr(b1+1,2)
auc(jj,j+1)=auc(jj,j+1)+tpr(b1+1,2)*(fpr(b1+1,2)-fpr(b1,2));
end
if (tpr(b1,2)~=tpr(b1+1,2))&(fpr(b1,2)~=fpr(b1+1,2))
auc(jj,j+1)=auc(jj,j+1)+(tpr(b1,2)+tpr(b1+1,2))*(fpr(b1+1,2)-fpr(b1,2))/2;
end
end
%%%%%%%%%%%%%%%%%%end auroc%%%%%%%%%%%%%%%%%%%%
end %end for j
end  %end for jj

for i=1:length(auc(1,:))
ave_auc(i,2)=mean(auc(:,17-i));
ave_auc(i,1)=i-6;
ave_auc(i,3)=std(auc(:,17-i));
ave_auc(i,4)=min(auc(:,17-i));
ave_auc(i,5)=max(auc(:,17-i));
end
plot(ave_auc(:,1),ave_auc(:,2),'k:o')