n_fe(50,11)=0;n_et(50,11)=0;
n_ET(11,5)=0;%%%%%%%%%
n_FE(11,5)=0;%%%%%%%%%
for m=1:11 
p=(m-1)*0.001;  %%%%%%% p is connection probability%%%%%%%
for cishu=1:50  %50 relizations

%%%%%%%%%%%%%%%%%% ER networks %%%%%%%%%%%%%
N=500;  %%%%%%%N is the network size
A=zeros(N);
for i=1:N
for j=1+i:N
clear b
b=rand(1,1);
if b<=p
nor=unifrnd(0,2,1,1);  
A(i,j)=nor;
%A(i,j)=1;  %%%%%%%%%%%% for unweight case
A(j,i)=A(i,j);
end
end
end

%%%%%%%%%%%for directed case%%%%%%%%%%%%%%%%
%for i=1:length(A)
%for j=i+1:length(A)
%ran=rand(1,1);
%if (A(i,j)~=0)&(ran<=0.5)
%A(i,j)=0;
%elseif (A(i,j)~=0)&(ran>0.5)
%A(j,i)=0;
%end
%end
%end
%%%%%%%%%%%end for directed case%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%end ER networks %%%%%%%%%%%%%


clear k1 ran b
k1(N,2)=0;
k1(1:N,1)=1:N;
k1(1:N,2)=sum(A(1:N,:));

for i=1:N
A(i,i)=-k1(i,2);
end
n_fe0=(N-rank(A))/length(A);
n_fe1=(N-rank(A+eye(N)))/N;
n_fe2=(N-rank(A+2*eye(N)))/N;
abc=[n_fe0,n_fe1,n_fe2];
n_fe(cishu,m)=max(abc);
if n_fe(cishu,m)<1/N
n_fe(cishu,m)=1/N;   %%%%%%%% fast estimation, FE method
end
clear abc n_fe0 n_fe1 n_fe2 k1 

A=A';
b(:,1)=eig(A);
b(:,2)=round(b(:,1)*10^10)/10^10;
r3=sort(b(:,2));
count=diff([r3;max(r3)+1]);       
 d1 = diff(find([1;count]));       
 y1 =[r3(find(count)) d1];
 y1=sortrows(y1,-2); 
clear count d1 r3 

y=[];                      % maximum geometric multiplicity, ET theory
if length(y1(:,1))>1
for xy=1:3
y2=find(b(:,2)==y1(xy,1));
y(xy,1)=N-rank(b(y2(1,1),1)*eye(N)-A);
end
else
y2=find(b(:,2)==y1(1,1));
y(1,1)=N-rank(b(y2(1,1),1)*eye(N)-A);
end
n_et(cishu,m)=max(y)/N;
clear b B A y y2 xy i y1
end %for cishu
n_ET(m,1)=p;
n_ET(m,2)=mean(n_et(:,m));
n_ET(m,3)=std(n_et(:,m));
n_ET(m,4)=min(n_et(:,m));
n_ET(m,5)=max(n_et(:,m));
n_FE(m,1)=p;
n_FE(m,2)=mean(n_fe(:,m));
n_FE(m,3)=std(n_fe(:,m));
n_FE(m,4)=min(n_fe(:,m));
n_FE(m,5)=max(n_fe(:,m));
end  %for m
errorbar(n_ET(:,1),n_ET(:,2),n_ET(:,3),'ko','LineWidth',1,'MarkerSize',12);
hold on
errorbar(n_FE(:,1),n_FE(:,2),n_FE(:,3),'k.','LineWidth',1,'MarkerSize',12);