n_fe(50,5)=0;n_et(50,5)=0;
n_ET(5,5)=0;%%%%%%%%%
n_FE(5,5)=0;%%%%%%%%%
for m=1:5 %%%%%% m is 2*average degree
for cishu=1:50  %50 relizations

%%%%%%%%%%%%%%%%%% BA networks %%%%%%%%%%%%%
N=500;  %%%%%%%N is the network size
A=zeros(N);
for i=1:m
    A(i,m+1)=1;
    A(m+1,i)=1;
    list(i)=i;
end
for i=m+1:2*m
    list(i)=m+1;
end
for n=m+2:N                  % start from m+2 to grow the network
    t=2*m*(n-m-1) ;           % for list, every time t increases 2m
    for i=1:m
        list(t+i)=n;          % in the list, every time the above m is n, it represents that the nth A is connected to other m A
    end
    k=1;
     while k<m+1               % grow other m A
        p(k)=round((t+1)*rand(1));         %    random choose an integer from 1~N
        if p(k)>0&p(k)<(t+1)
            if A(n,list(p(k)))==0
               list(t+m+k)=list(p(k));
                A(n,list(p(k)))=1;
                A(list(p(k)),n)=1;
                k=k+1;
            end   %end for j
         end    %end for k
    end %end for n
end
clear i p k list n t

%%%%%%%%%%%for weight case%%%%%%%%%%%%%%%%
%for i=1:length(A)
%for j=1+i:length(A)
%if A(i,j)~=0
%nor=unifrnd(0,2,1,1);
%A(i,j)=nor;
%A(j,i)=A(i,j);
%end
%end
%end
%%%%%%%%%%%end for weight case%%%%%%%%%%%%%%%%

%%%%%%%%%%%for directed case%%%%%%%%%%%%%%%%
%for i=1:length(A)
%for j=i+1:length(A)
%ran=rand(1,1);
%if (A(i,j)~=0)&(ran<=0.5)
%A(i,j)=0;
%elseif (A(i,j)~=0)&(ran>0.5)
%A(j,i)=0;
%end
%end
%end
%%%%%%%%%%%end for directed case%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%end BA networks %%%%%%%%%%%%%


clear k1 ran
k1(N,2)=0;
k1(1:N,1)=1:N;
k1(1:N,2)=sum(A(1:N,:));
for i=1:N
A(i,i)=-k1(i,2);
end
n_fe0=(N-rank(A))/N;
n_fe1=(N-rank(A+eye(N)))/N;
n_fe2=(N-rank(A+2*eye(N)))/N;
abc=[n_fe0,n_fe1,n_fe2];
n_fe(cishu,m)=max(abc);
if n_fe(cishu,m)<1/N
n_fe(cishu,m)=1/N;   %%%%%%%% fast estimation, FE method
end
clear abc n_fe0 n_fe1 n_fe2 k1 

A=A';
b(:,1)=eig(A);
b(:,2)=round(b(:,1)*10^10)/10^10;
r3=sort(b(:,2));
count=diff([r3;max(r3)+1]);       
 d1 = diff(find([1;count]));       
 y1 =[r3(find(count)) d1];
 y1=sortrows(y1,-2); 
clear count d1 r3 

y=[];                      % maximum geometric multiplicity, ET theory
if length(y1(:,1))>1
for xy=1:3
y2=find(b(:,2)==y1(xy,1));
y(xy,1)=N-rank(b(y2(1,1),1)*eye(N)-A);
end
else
y2=find(b(:,2)==y1(1,1));
y(1,1)=N-rank(b(y2(1,1),1)*eye(N)-A);
end
n_et(cishu,m)=max(y)/N;
clear b B A y y2 xy i y1
end %for cishu
n_ET(m,1)=2*m;
n_ET(m,2)=mean(n_et(:,m));
n_ET(m,3)=std(n_et(:,m));
n_ET(m,4)=min(n_et(:,m));
n_ET(m,5)=max(n_et(:,m));
n_FE(m,1)=2*m;
n_FE(m,2)=mean(n_fe(:,m));
n_FE(m,3)=std(n_fe(:,m));
n_FE(m,4)=min(n_fe(:,m));
n_FE(m,5)=max(n_fe(:,m));
end  %for m
errorbar(n_ET(:,1),n_ET(:,2),n_ET(:,3),'ko','LineWidth',1,'MarkerSize',12);
hold on
errorbar(n_FE(:,1),n_FE(:,2),n_FE(:,3),'k.','LineWidth',1,'MarkerSize',12);