mp.Digits(100);
n1=4;  %the number of initial sources
beta=0.05;%the parameter of adjusting the difusion rate 
sigma=0; %noise,  standard deviation 
data=0.5; %data rate
%%%%%%%%%%%%%%%%%% BA networks %%%%%%%%%%%%%
N=mp('50');A=zeros(N);m=2;%%%%%%%N is the network size, m is 2*average degree%%%%%%%
NN=50;
for i=1:m
    A(i,m+1)=1;
    A(m+1,i)=1;
    list(i)=i;
end
for i=m+1:2*m
    list(i)=m+1;
end
for n=m+2:N                  % start from m+2 to grow the network
    t=2*m*(n-m-1) ;           % for list, every time t increases 2m
    for i=1:m
        list(t+i)=n;          % in the list, every time the above m is n, it represents that the nth A is connected to other m A
    end
    k=1;
    while k<m+1               % grow other m A
        p(k)=round((t+1)*rand(1));         %    random choose an integer from 1~N
        if p(k)>0&p(k)<(t+1)
            if A(n,list(p(k)))==0
                list(t+m+k)=list(p(k));
                A(n,list(p(k)))=1;
                A(list(p(k)),n)=1;
                k=k+1;
            end   %end for j
        end    %end for k
    end %end for n
end
clear i p k list n t

%%%%%%%%%%%% for weight case%%%%%%%%%%%%%
for i=1:NN
for j=1+i:NN
if A(i,j)==1
nor=unifrnd(mp('0'),mp('2'),1,1);
A(i,j)=nor;
A(j,i)=A(i,j);
end
end
end
%%%%%%%%%%%%%%%end for weight case%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%end BA networks %%%%%%%%%%%%%

A1=A;
k1(NN,2)=mp('1');
for i=1:NN
    k1(i,1)=i;
    k1(i,2)=sum(A(i,:));
end
for i=1:NN
    A(i,i)=-k1(i,2);
end
B=beta*A+eye(NN);
%%%%%%%%%%%%%%%%%%% HPB test to identify messengers %%%%%%%%%%%%%%%%%%%%
clear A jb1
jb1(1:i,1)=1:i;
c=eig(B);
clear ans count r3 d1 y3  C C1      
r3=sort(round(c*10^15)/10^15);
count=diff([r3;max(r3)+1]);
d1 = diff(find([1;count]));
y3 =[r3(find(count)) d1];
y3=sortrows(y3,-2);

clear C w
C(1,1:NN)=0; %%%%%%C is the output matrix and the nonzero enrty means which node is messenger%%%%%%%%
y=[];
C1=zeros(NN);jb=[];r=[];y0=[];
C1=y3(1,1)*eye(NN)-B;
[r,jb]=rref(double(C1));
jb=jb';
y0 = setdiff(jb1, jb);
for w=1:length(y0)
    C(w,y0(w,1))=1;
end
if C(:)==0
    C(1,NN)=1;
end
%%%%%%%%%%%%%%%%%%% end HPB test to identify messengers %%%%%%%%%%%%%%%%%%%%

A=A1;
a=[];t0=200;   %%%%%%%%%difussion time step is set to 200
b=randperm(NN);
a=b(1:n1);  %create sources by random
a=a';
a=sort(a);
k1(:,3:4)=0;
for i=1:length(a)
    b=unifrnd(mp('0'),mp('1'),1,1);
    k1(a(i,1),3)=b;
    k1(a(i,1),4)=b;
    clear b
end

%%%%%%%%%%%%%%% difussion process%%%%%%%%%%%%%% 
rou(NN,t0+1)=mp('0');
rou(:,1)=k1(:,4);
for t=1:t0
    for i=1:NN
        rou(i,t+1)=rou(i,t)+beta*(A1(:,i)'*rou(:,t)-k1(i,2)*rou(i,t));
    end
end
%%%%%%%%%%%%%%% end difussion process%%%%%%%%%%%%%%
clear A
A=B;
pn0=randperm(NN);
pn=sort(pn0(1:(data*NN))'); %data rate
D1=[]; %%%%%%%%% observation matrix
clear pn0
for k=1:length(pn)
    clear D
    D=C*A^(pn(k,1)-1);           
    D1=[D1;D];
end

clear Y x11 D2 x1  x12
Y=[]; %%%%%%%%% output vector
for i=1:length(pn) 
    Y=[Y;C*rou(:,pn(i,1))];  
end

j=1;
for i=(data*NN-1):-1:1   %observe before difussion starting
    clear x11 Y1 Y2 x1 D2
Y1(i*length(C(:,1)),1)=0;
D2=D1(1:(length(D1(:,1))-i*length(C(:,1))),:);
Y2=Y(1:(length(D1(:,1))-i*length(C(:,1))),:);

y=Y2*(1+sigma*normrnd(0,1)); %%%%%%%%% the output vector we obtain last
clear Y2
Y2=y;
clear y
x11=pinv(D2)*Y2;
%x11=D2\Y2;
x1=l1eq_pd(x11, D2, [], Y2, mp('1e-8')); %x1 reconstruction initial state
x12(:,j)=x1;
j=j+1;
end

for tt=0:1:100  %for example the max initial observation time is 100 after diffusing
Y=[]; 
clear x11 D2 x1 
for i=1:length(pn) 
    Y=[Y;C*rou(:,pn(i,1)+tt)];  
end
D2=D1*A^tt;

y=Y*(1+sigma*normrnd(0,1));
clear Y
Y=y;
clear y
x11=pinv(D2)*Y;
%x11=D2\Y;
x1=l1eq_pd(x11, D2, [], Y, mp('1e-8'));
x12(:,j)=x1;
j=j+1;
end

rou1=double(rou);
x12=double(x12);
figure
imagesc(x12) %%%%%%%%%%reconstruction initial state of every node for different initial observation time

j=1;
tt=3;
Y=[]; 
clear x11 D2 x1 
for i=1:length(pn) 
    Y=[Y;C*rou(:,pn(i,1)+tt)];  
end
clear y
y=Y*(1+sigma*normrnd(0,1));
clear Y
Y=y;
clear y

for j=2*tt:-1:0  %reconstruction time steps is set to 2*tt.
clear D2 x11 x1
D2=D1*A^j;

x11=pinv(D2)*Y;
%x11=D2\Y;
x1=l1eq_pd(x11, D2, [], Y, mp('1e-8'));
x13(:,2*tt+1-j)=x1;
end

x13=double(x13);
figure
imagesc(x13)  %%%%%%%%%%reconstruction state of every node at every time step when initial observation time is fixed, 3 for example